Public Class Node
    Public value As String = ""
    Public editable As Boolean = False
    Public nodes As New ArrayList
    Public positions As New ArrayList
    Public deleted As Boolean = False

    Public selectedcol As Integer = 0
    Public selectedrow As Integer = 0

    Public Sub New()
    End Sub

    Public Sub New(ByVal v As String)
        value = v
    End Sub

    Public Overridable Function getValue() As String
        Return value
    End Function

    Public Function getLowestCol() As Integer
        Dim col As Integer = 0

        For i As Integer = 0 To positions.Count - 1
            If positions(i).getvalue(0) < col Then col = positions(i).getvalue(0)
        Next

        Return col
    End Function

    Public Function getHighestCol() As Integer
        Dim col As Integer = 0

        For i As Integer = 0 To positions.Count - 1
            If positions(i).getvalue(0) > col Then col = positions(i).getvalue(0)
        Next

        Return col
    End Function

    Public Function getLowestRow() As Integer
        Dim row As Integer = 0

        For i As Integer = 0 To positions.Count - 1
            If positions(i).getvalue(1) < row Then row = positions(i).getvalue(1)
        Next

        Return row
    End Function

    Public Function getHighestRow() As Integer
        Dim row As Integer = 0

        For i As Integer = 0 To positions.Count - 1
            If positions(i).getvalue(1) > row Then row = positions(i).getvalue(1)
        Next

        Return row
    End Function

    Public Function getFreePosition() As NodePosition
        Dim np As NodePosition
        Dim highestrowindex As Integer = -1

        For i As Integer = 0 To positions.Count - 1
            If positions(i).getcolvalue() = 0 Then
                If highestrowindex >= 0 Then
                    If positions(i).getrowvalue() > positions(highestrowindex).getrowvalue() Then highestrowindex = i
                Else
                    highestrowindex = i
                End If
            End If
        Next

        Dim freeposition As NodePosition

        If highestrowindex >= 0 Then
            freeposition = New NodePosition(0, positions(highestrowindex).getrowvalue() + 1)
        Else
            freeposition = New NodePosition(0, 0)
        End If

        Return freeposition
    End Function

    Public Sub add(ByVal n As Node)
        nodes.Add(n)
        positions.Add(getFreePosition())
    End Sub

    Public Sub add(ByVal n As Node, ByVal col As Integer, ByVal row As Integer)
        nodes.Add(n)
        positions.Add(New NodePosition(col, row))
    End Sub

    Public Function getSelectedNode() As Node
        Dim n As Node = Nothing

        For i As Integer = 0 To positions.Count - 1
            If positions(i).getcolvalue() = selectedcol And positions(i).getrowvalue() = selectedrow Then
                n = nodes(i)
                Exit For
            End If
        Next

        Return n
    End Function

    Public Sub KeyPress(ByVal c As Char)
        value += c
        onKeyPress(c)
    End Sub

    Public Overridable Sub onKeyPress(ByVal c As Char)
    End Sub

    Public Overridable Function onDescendInto() As Integer
        Return 0
    End Function

    Public Sub clear()
        Dim n As Node
        For Each n In nodes
            n.clear()
            n.deleted = True
            n = Nothing
        Next

        value = ""
        editable = False
        nodes.Clear()
        positions.Clear()
        selectedcol = 0
        selectedrow = 0
    End Sub
End Class
