Public Class NodeForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtKeyPress As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtKeyPress = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'txtKeyPress
        '
        Me.txtKeyPress.Location = New System.Drawing.Point(-20, 0)
        Me.txtKeyPress.Name = "txtKeyPress"
        Me.txtKeyPress.Size = New System.Drawing.Size(9, 20)
        Me.txtKeyPress.TabIndex = 0
        Me.txtKeyPress.Text = ""
        '
        'NodeForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 271)
        Me.ControlBox = False
        Me.Controls.Add(Me.txtKeyPress)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow
        Me.KeyPreview = True
        Me.Name = "NodeForm"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim currentnode As Node
    Dim sr As ScreenReader

    Private Sub NodeForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Public Sub setScreenReader(ByVal s As ScreenReader)
        sr = s
    End Sub

    Private Function getNodeWidth() As Integer
        Return Me.Width / (currentnode.getHighestCol() + 1 - currentnode.getLowestCol())
    End Function

    Private Function getNodeHeight() As Integer
        Return (Me.Height - 32) / (currentnode.getHighestRow() + 1 - currentnode.getLowestRow())
    End Function

    Public Sub showChildren()
        'Me.Controls.Clear()

        While Me.Controls.Count > 1
            Controls.RemoveAt(Controls.Count - 1)
        End While

        For i As Integer = 0 To currentnode.nodes.Count - 1
            Dim lbl As New Label
            lbl.Text = currentnode.nodes(i).value
            lbl.Font = New Font("Microsoft Sans Serif", 14.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            Me.Controls.Add(lbl)
            lbl.Top = currentnode.positions(i).getrowvalue() * getNodeHeight()
            lbl.Left = currentnode.positions(i).getcolvalue() * getNodeWidth()
            lbl.Width = getNodeWidth()
            lbl.Height = getNodeHeight()
        Next
    End Sub

    Public Sub setNode(ByVal n As Node)
        If currentnode Is n Then
        Else
            currentnode = n
            Me.Text = "Node:  " & n.value
            showChildren()
        End If
    End Sub

    Private Function getSelectedLabel() As Label
        Dim lbl As Label

        For i As Integer = 0 To currentnode.positions.Count - 1
            If currentnode.positions(i).getcolvalue() = currentnode.selectedcol And currentnode.positions(i).getrowvalue() = currentnode.selectedrow Then
                lbl = Me.Controls(i + 1)
                Exit For
            End If
        Next

        Return lbl
    End Function

    'Private Sub highlightChild(ByVal p As Pen)
    '    If Not currentnode.getSelectedNode() Is Nothing Then
    '        Dim lbl As Label = getSelectedLabel()
    '        Dim g As Graphics = lbl.CreateGraphics()
    '        g.DrawRectangle(p, 0, 0, lbl.Width - 1, lbl.Height - 1)
    '    End If
    'End Sub

    Public Sub highlightChild(ByVal highlight As Boolean)
        If Not currentnode.getSelectedNode() Is Nothing Then
            Dim lbl As Label = getSelectedLabel()
            If highlight Then
                lbl.ForeColor = System.Drawing.SystemColors.HighlightText
                lbl.BackColor = System.Drawing.SystemColors.Highlight
            Else
                lbl.ForeColor = System.Drawing.SystemColors.ControlText
                lbl.BackColor = System.Drawing.SystemColors.Control
            End If
        End If
    End Sub

    Private Sub NodeForm_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        'highlightChild(Pens.Black)
        highlightChild(False)

        sr.interpret(e.KeyChar)
        setNode(sr.currentnode)

        'highlightChild(Pens.White)
        highlightChild(True)

        If sr.mode Then
            Me.Text = currentnode.value & "_"
        Else
            Me.Text = "Node:  " & currentnode.value
        End If
    End Sub

    Private Sub NodeForm_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.LostFocus
    End Sub

    Private Sub txtKeyPress_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtKeyPress.LostFocus
        txtKeyPress.Focus()
    End Sub

    Private Sub txtKeyPress_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtKeyPress.TextChanged
        txtKeyPress.Text = ""
    End Sub
End Class
